import { ISourceCFG } from '@antv/l7-core';
import BaseLayer from '../core/BaseLayer';
interface IEarthLayerStyleOptions {
    opacity: number;
    setEarthTime(time: number): void;
}
export type EarthModelType = 'base' | 'atomSphere' | 'bloomSphere';
export default class EarthLayer extends BaseLayer<IEarthLayerStyleOptions> {
    type: string;
    defaultSourceConfig: {
        data: any[];
        options: ISourceCFG | undefined;
    };
    buildModels(): Promise<void>;
    /**
     * 设置当前地球时间
     * @param time
     */
    setEarthTime(time: number): void;
    getModelType(): EarthModelType;
}
export {};
